"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@babel/core");
var convertToPropTypes_1 = __importDefault(require("./convertToPropTypes"));
var extractGenericTypeNames_1 = __importDefault(require("./extractGenericTypeNames"));
var mergePropTypes_1 = __importDefault(require("./mergePropTypes"));
function addToClass(node, state) {
    if (!node.superTypeParameters || node.superTypeParameters.params.length <= 0) {
        return;
    }
    // @ts-ignore
    var typeNames = extractGenericTypeNames_1.default(node.superTypeParameters.params[0]);
    var propTypesList = convertToPropTypes_1.default(state.componentTypes, typeNames, state);
    var hasPropTypesStaticProperty = false;
    if (propTypesList.length === 0) {
        return;
    }
    node.body.body.forEach(function (property) {
        var valid = core_1.types.isClassProperty(property, { static: true }) &&
            core_1.types.isIdentifier(property.key, { name: 'propTypes' }) &&
            core_1.types.isObjectExpression(property.value);
        if (valid) {
            hasPropTypesStaticProperty = true;
            // Merge with existing `propTypes`
            mergePropTypes_1.default(property.value, propTypesList);
        }
    });
    // Add a new static `propTypes` class property
    if (!hasPropTypesStaticProperty) {
        var staticProperty = core_1.types.classProperty(core_1.types.identifier('propTypes'), core_1.types.objectExpression(propTypesList));
        // @ts-ignore
        staticProperty.static = true;
        node.body.body.unshift(staticProperty);
    }
}
exports.default = addToClass;
