"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@babel/core");
var convertToPropTypes_1 = __importDefault(require("./convertToPropTypes"));
var extractGenericTypeNames_1 = __importDefault(require("./extractGenericTypeNames"));
var mergePropTypes_1 = __importDefault(require("./mergePropTypes"));
function addToFunctionOrVar(path, name, state) {
    var typeNames = [];
    if (core_1.types.isFunctionDeclaration(path.node)) {
        typeNames.push.apply(typeNames, extractGenericTypeNames_1.default(
        // @ts-ignore
        path.node.params[0].typeAnnotation.typeAnnotation));
    }
    else if (core_1.types.isVariableDeclaration(path.node)) {
        typeNames.push.apply(typeNames, extractGenericTypeNames_1.default(
        // @ts-ignore
        path.node.declarations[0].id.typeAnnotation.typeAnnotation.typeParameters.params[0]));
    }
    var propTypesList = convertToPropTypes_1.default(state.componentTypes, typeNames, state);
    if (typeNames.length === 0 || propTypesList.length === 0) {
        return;
    }
    var rootPath = core_1.types.isExportNamedDeclaration(path.parent) || core_1.types.isExportDefaultDeclaration(path.parent)
        ? path.parentPath
        : path;
    var existingExpr = rootPath
        .getAllNextSiblings()
        .filter(function (sibPath) {
        return core_1.types.isExpressionStatement(sibPath.node) &&
            core_1.types.isAssignmentExpression(sibPath.node.expression, { operator: '=' }) &&
            core_1.types.isMemberExpression(sibPath.node.expression.left) &&
            core_1.types.isObjectExpression(sibPath.node.expression.right) &&
            core_1.types.isIdentifier(sibPath.node.expression.left.object, { name: name }) &&
            core_1.types.isIdentifier(sibPath.node.expression.left.property, { name: 'propTypes' });
    });
    // Merge with existing `propTypes`
    if (existingExpr.length === 1) {
        var statement = existingExpr[0].node;
        var expression = statement.expression;
        mergePropTypes_1.default(expression.right, propTypesList);
        // Create a new `propTypes` expression
    }
    else {
        rootPath.insertAfter(core_1.types.expressionStatement(core_1.types.assignmentExpression('=', core_1.types.memberExpression(core_1.types.identifier(name), core_1.types.identifier('propTypes')), core_1.types.objectExpression(propTypesList))));
    }
}
exports.default = addToFunctionOrVar;
