"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@babel/core");
var getTypeName_1 = __importDefault(require("./getTypeName"));
function extractGenericTypeNames(node) {
    var names = [];
    // <Foo>
    if (core_1.types.isTSTypeParameterInstantiation(node)) {
        node.params.forEach(function (param) {
            names.push.apply(names, extractGenericTypeNames(param));
        });
        // Foo
    }
    else if (core_1.types.isTSTypeReference(node)) {
        names.push(getTypeName_1.default(node.typeName));
        // Foo & Bar, Foo | Bar
    }
    else if (core_1.types.isTSIntersectionType(node) || core_1.types.isTSUnionType(node)) {
        node.types.forEach(function (param) {
            names.push.apply(names, extractGenericTypeNames(param));
        });
    }
    return names;
}
exports.default = extractGenericTypeNames;
